/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3DMFNODEFUNCTOR_H
#define X3DTK_X3DMFNODEFUNCTOR_H

namespace X3DTK {

class X3DAbstractNode;

class X3DMFNodeFunctor
{
public:
  virtual ~X3DMFNodeFunctor() {}
  virtual const MFNode &getNodes(X3DAbstractNode const *N) = 0;
  virtual bool addNode(X3DAbstractNode *N, X3DAbstractNode *C) = 0;
  virtual bool removeNode(X3DAbstractNode *N, X3DAbstractNode *C) = 0;
  virtual void removeTheseNodes(X3DAbstractNode *N) = 0;
};

template<class T, class V>
class MFNodeFunctor : public X3DMFNodeFunctor
{
public:
  MFNodeFunctor(MFNode T:: *node);
  
  const MFNode &getNodes(X3DAbstractNode const *N);
  bool addNode(X3DAbstractNode *N, X3DAbstractNode *C);
  bool removeNode(X3DAbstractNode *N, X3DAbstractNode *C);
  void removeTheseNodes(X3DAbstractNode *N);
  
private:
  MFNode T::*_nodes;
};

}

#include "X3DMFNodeFunctor.inl"

#endif
